# global
import math


# Array API Standard #
# -------------------#

e = math.e
"""IEEE 754 floating-point representation of Euler's constant."""

pi = math.pi
"""IEEE 754 floating-point representation of the mathematical constant π."""

nan = math.nan
"""IEEE 754 floating-point representation of Not a Number (NaN)."""

inf = math.inf
"""IEEE 754 floating-point representation of (positive) infinity."""

newaxis = None
"""An alias for None which is useful for indexing arrays."""


# Mathematical constants #
# ------#

golden = golden_ratio = (1 + math.sqrt(5)) / 2
quetta = 1e30
ronna = 1e27
yotta = 1e24
zetta = 1e21
exa = 1e18
peta = 1e15
tera = 1e12
giga = 1e9
mega = 1e6
kilo = 1e3
hecto = 1e2
deka = 1e1
deci = 1e-1
centi = 1e-2
milli = 1e-3
micro = 1e-6
nano = 1e-9
pico = 1e-12
femto = 1e-15
atto = 1e-18
zepto = 1e-21
yocto = 1e-24
ronto = 1e-27
quecto = 1e-30


# Binary prefixes #
# ------#

kibi = 2**10
mebi = 2**20
gibi = 2**30
tebi = 2**40
pebi = 2**50
exbi = 2**60
zebi = 2**70
yobi = 2**80
